import * as tslib_1 from "tslib";
import { autobind, decorate } from "core-decorators";
import moize from "moize";
import * as React from "react";
import { styleSheetParser, rootColumnIndex, subColumnIndex, isRootColumn } from "./";
let Header = class Header extends React.PureComponent {
    onSort(rootColIndex, subColIndex) {
        return () => this.props.onSort(rootColIndex, subColIndex);
    }
    render() {
        return (React.createElement("thead", null,
            React.createElement("tr", { className: styleSheetParser.mainHeader },
                this.props.onToggleAll && !this.props.hideSelect ? (React.createElement("th", { rowSpan: 2, className: styleSheetParser.selectHeader },
                    React.createElement("input", { type: "checkbox", checked: this.props.areAllRowsSelected, onChange: this.props.onToggleAll }))) : null,
                this.props.columns.map((col, i) => {
                    const isCurrentColumnSorted = rootColumnIndex(this.props.columns, i) === this.props.currentSortedColumn;
                    const rootCol = col;
                    return (React.createElement("th", { key: col.label || i, rowSpan: rootCol.subColumns && rootCol.subColumns.length ? 1 : 2, colSpan: rootCol.subColumns && rootCol.subColumns.length ? rootCol.subColumns.length : 1, className: (col.featured ? styleSheetParser.featured : "")
                            + " " + (col.className || "")
                            + " " + (this.props.headerCellClassName || "")
                            + " " + ((rootCol.subColumns && rootCol.subColumns.length) ? styleSheetParser.rootHeader : "") },
                        col.label,
                        !isRootColumn(col) && col.sort ?
                            React.createElement("span", { className: styleSheetParser.sortIcon + (isCurrentColumnSorted ? ` ${styleSheetParser.activeSortIcon}` : ""), onClick: this.onSort(i) },
                                React.createElement("span", { className: isCurrentColumnSorted && this.props.ascendant ? styleSheetParser.up : styleSheetParser.down }))
                            : null));
                })),
            React.createElement("tr", { className: styleSheetParser.subHeader }, this.props.columns.map((col, i) => {
                if (isRootColumn(col)) {
                    return col.subColumns.map((subCol, j) => {
                        const isCurrentColumn = subColumnIndex(this.props.columns, j, i) === this.props.currentSortedColumn;
                        return (React.createElement("th", { key: `${col.label}/${subCol.label}` },
                            subCol.label,
                            subCol.sort ?
                                React.createElement("span", { className: styleSheetParser.sortIcon + (isCurrentColumn ? ` ${styleSheetParser.activeSortIcon}` : ""), onClick: this.onSort(i, j) },
                                    React.createElement("span", { className: isCurrentColumn && this.props.ascendant ? styleSheetParser.down : styleSheetParser.up }))
                                : null));
                    }).reduce((arr, cols) => arr.concat(cols), []);
                }
                return null;
            }).filter((a) => a))));
    }
};
tslib_1.__decorate([
    decorate(moize)
], Header.prototype, "onSort", null);
Header = tslib_1.__decorate([
    autobind
], Header);
export default Header;
//# sourceMappingURL=header.js.map