export const falsySorter = (a, b) => {
    if (!a && !b) {
        return 0;
    }
    else if (!a) {
        return -Infinity;
    }
    else if (!b) {
        return Infinity;
    }
    else {
        return NaN;
    }
};
export const stringSorter = (a, b) => {
    if (!a || !b) {
        return falsySorter(a, b);
    }
    return a.localeCompare(b);
};
export const numberSorter = (a, b) => {
    if (!a || !b) {
        return falsySorter(a, b);
    }
    return a - b;
};
export const dateSorter = (a, b) => {
    if (!a || !b) {
        return falsySorter(a, b);
    }
    return a.valueOf() - b.valueOf();
};
//# sourceMappingURL=sorters.js.map