import * as React from "react";
import * as faker from "faker";
import { TestDataTable } from "../data";
import { storiesOf } from '@kadira/storybook';
faker.locale = "pt_BR";
function genTableFromDescriptor(desc = {}, selectable = false) {
    return () => (React.createElement(TestDataTable, Object.assign({}, desc, { selectable: selectable })));
}
function addStories(story, opt = {}, selectable) {
    return story
        .add('default view', genTableFromDescriptor(Object.assign({}, opt), selectable))
        .add('empty state with placeholder', genTableFromDescriptor(Object.assign({ numberOfRows: 0 }, opt), selectable))
        .add('nested columns', genTableFromDescriptor(Object.assign({ subColumns: true }, opt), selectable))
        .add('nested cells', genTableFromDescriptor(Object.assign({ subCells: true }, opt), selectable))
        .add('nested columns & cells', genTableFromDescriptor(Object.assign({ subCells: true, subColumns: true }, opt), selectable));
}
addStories(storiesOf('DataTable', module));
addStories(storiesOf('DataTable/Featured Row', module), { featuredRow: true });
addStories(storiesOf('DataTable/Featured Row', module), { featuredRow: true });
addStories(storiesOf('DataTable/Categorized', module), { categorized: true });
addStories(storiesOf('DataTable/Categorized & Totalized', module), { categorized: true, totalFunction: true });
addStories(storiesOf('DataTable/Sortable', module), { sortable: true });
addStories(storiesOf('DataTable/Sortable & Categorized', module), { sortable: true, categorized: true });
addStories(storiesOf('DataTable/Selectable', module), {}, true);
addStories(storiesOf('DataTable/Selectable & Categorized', module), { categorized: true }, true);
addStories(storiesOf('DataTable/Sortable & Selectable', module), { sortable: true }, true);
addStories(storiesOf('DataTable/Sortable, Categorized & Selectable', module), { sortable: true, categorized: true }, true);
addStories(storiesOf('DataTable/Sortable, Categorized, Totalized, Featured & Selectable', module), { sortable: true, categorized: true, totalFunction: true, featuredRow: true }, true);
addStories(storiesOf('Huge DataTable', module), { numberOfRows: 3E3 }, true);
addStories(storiesOf('Huge DataTable/Sortable, Categorized, Totalized, Featured & Selectable', module), { sortable: true, categorized: true, totalFunction: true, featuredRow: true, numberOfRows: 3E3 }, true);
//# sourceMappingURL=index.js.map