import * as React from "react";
import { RowId, BasicRow, CategorizedRow, DataColumn, DataRow } from "../";
export declare type SingleOrArray<T> = T | T[];
export declare type ColumnContent = SingleOrArray<string> | SingleOrArray<number> | SingleOrArray<Date>;
export interface ColumnDescriptor<V extends ColumnContent = ColumnContent> {
    content?: V | ((i: number) => V);
    computedNode?: (v: V) => React.ReactNode;
    label: string;
    sort?: (v1: V | null | undefined, v2: V | null | undefined) => number;
    subColumns?: ColumnDescriptor[];
    className?: string;
    featured?: boolean;
}
export interface StandardFakeOptions {
    sortable?: boolean;
    subCells?: boolean;
    subColumns?: boolean;
    selectable?: boolean;
    categorized?: boolean;
    numberOfRows?: number;
    featuredRow?: boolean;
    totalFunction?: boolean;
    preComputeNodes?: boolean;
}
export declare function generateStandardFakeData(options?: StandardFakeOptions): GeneratedData;
export interface GeneratedData {
    columns: DataColumn[];
    data: BasicRow[] | CategorizedRow[];
    featuredRow?: DataRow;
    totalFunction?: (rows: DataRow[], category: RowId | undefined) => DataRow;
}
export declare function generateRows(cols: ColumnDescriptor[], options: StandardFakeOptions): GeneratedData;
export declare class TestDataTable extends React.Component<StandardFakeOptions, GeneratedData> {
    constructor(props: StandardFakeOptions);
    onSelect: (id: string | number | RowId[], selected: boolean) => void;
    render(): JSX.Element;
}
