function __$styleInject(css, returnValue) {
  if (typeof document === 'undefined') {
    return returnValue;
  }
  css = css || '';
  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';
  head.appendChild(style);
  
  if (style.styleSheet){
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
  return returnValue;
}

import { PureComponent, createElement } from 'react';
import * as React from 'react';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
  return typeof obj;
} : function (obj) {
  return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
};











var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();









var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};











var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};





var slicedToArray = function () {
  function sliceIterator(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"]) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  return function (arr, i) {
    if (Array.isArray(arr)) {
      return arr;
    } else if (Symbol.iterator in Object(arr)) {
      return sliceIterator(arr, i);
    } else {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }
  };
}();













var toConsumableArray = function (arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  } else {
    return Array.from(arr);
  }
};

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */







function __decorate(decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if ((typeof Reflect === "undefined" ? "undefined" : _typeof(Reflect)) === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);else for (var i = decorators.length - 1; i >= 0; i--) {
        if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    }return c > 3 && r && Object.defineProperty(target, key, r), r;
}

var defineProperty$2 = Object.defineProperty;

function handleDescriptor$1(target, key, descriptor) {
  var configurable = descriptor.configurable,
      enumerable = descriptor.enumerable,
      initializer = descriptor.initializer,
      value = descriptor.value;

  return {
    configurable: configurable,
    enumerable: enumerable,

    get: function get() {
      // This happens if someone accesses the
      // property directly on the prototype
      if (this === target) {
        return;
      }

      var ret = initializer ? initializer.call(this) : value;

      defineProperty$2(this, key, {
        configurable: configurable,
        enumerable: enumerable,
        writable: true,
        value: ret
      });

      return ret;
    },

    set: createDefaultSetter(key)
  };
}

function lazyInitialize() {
  for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  return decorate(handleDescriptor$1, args);
}

var _typeof$2 = typeof Symbol === "function" && _typeof(Symbol.iterator) === "symbol" ? function (obj) {
  return typeof obj === "undefined" ? "undefined" : _typeof(obj);
} : function (obj) {
  return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj === "undefined" ? "undefined" : _typeof(obj);
};

var _class;
var _descriptor;
var _descriptor2;
var _descriptor3;
var _descriptor4;
var _descriptor5;

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _classCallCheck$1(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _toConsumableArray(arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) {
      arr2[i] = arr[i];
    }return arr2;
  } else {
    return Array.from(arr);
  }
}

var getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;
var getOwnPropertyNames = Object.getOwnPropertyNames;
var getOwnPropertySymbols = Object.getOwnPropertySymbols;

function isDescriptor(desc) {
  if (!desc || !desc.hasOwnProperty) {
    return false;
  }

  var keys = ['value', 'initializer', 'get', 'set'];

  for (var i = 0, l = keys.length; i < l; i++) {
    if (desc.hasOwnProperty(keys[i])) {
      return true;
    }
  }

  return false;
}

function decorate(handleDescriptor, entryArgs) {
  if (isDescriptor(entryArgs[entryArgs.length - 1])) {
    return handleDescriptor.apply(undefined, _toConsumableArray(entryArgs).concat([[]]));
  } else {
    return function () {
      return handleDescriptor.apply(undefined, Array.prototype.slice.call(arguments).concat([entryArgs]));
    };
  }
}

var Meta = (_class = function Meta() {
  _classCallCheck$1(this, Meta);

  _initDefineProp(this, 'debounceTimeoutIds', _descriptor, this);

  _initDefineProp(this, 'throttleTimeoutIds', _descriptor2, this);

  _initDefineProp(this, 'throttlePreviousTimestamps', _descriptor3, this);

  _initDefineProp(this, 'throttleTrailingArgs', _descriptor4, this);

  _initDefineProp(this, 'profileLastRan', _descriptor5, this);
}, (_descriptor = _applyDecoratedDescriptor(_class.prototype, 'debounceTimeoutIds', [lazyInitialize], {
  enumerable: true,
  initializer: function initializer() {
    return {};
  }
}), _descriptor2 = _applyDecoratedDescriptor(_class.prototype, 'throttleTimeoutIds', [lazyInitialize], {
  enumerable: true,
  initializer: function initializer() {
    return {};
  }
}), _descriptor3 = _applyDecoratedDescriptor(_class.prototype, 'throttlePreviousTimestamps', [lazyInitialize], {
  enumerable: true,
  initializer: function initializer() {
    return {};
  }
}), _descriptor4 = _applyDecoratedDescriptor(_class.prototype, 'throttleTrailingArgs', [lazyInitialize], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor5 = _applyDecoratedDescriptor(_class.prototype, 'profileLastRan', [lazyInitialize], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
})), _class);



var getOwnKeys = getOwnPropertySymbols ? function (object) {
  return getOwnPropertyNames(object).concat(getOwnPropertySymbols(object));
} : getOwnPropertyNames;

function getOwnPropertyDescriptors(obj) {
  var descs = {};

  getOwnKeys(obj).forEach(function (key) {
    return descs[key] = getOwnPropertyDescriptor(obj, key);
  });

  return descs;
}

function createDefaultSetter(key) {
  return function set$$1(newValue) {
    Object.defineProperty(this, key, {
      configurable: true,
      writable: true,
      // IS enumerable when reassigned by the outside word
      enumerable: true,
      value: newValue
    });

    return newValue;
  };
}

function bind(fn, context) {
  if (fn.bind) {
    return fn.bind(context);
  } else {
    return function __autobind__() {
      return fn.apply(context, arguments);
    };
  }
}

var warn = function () {
  if ((typeof console === 'undefined' ? 'undefined' : _typeof$2(console)) !== 'object' || !console || typeof console.warn !== 'function') {
    return function () {};
  } else {
    return bind(console.warn, console);
  }
}();

var _typeof$1 = typeof Symbol === "function" && _typeof(Symbol.iterator) === "symbol" ? function (obj) {
  return typeof obj === "undefined" ? "undefined" : _typeof(obj);
} : function (obj) {
  return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj === "undefined" ? "undefined" : _typeof(obj);
};

var _createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);
    }
  }return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;
  };
}();

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

var GENERIC_FUNCTION_ERROR = '{child} does not properly override {parent}';
var FUNCTION_REGEXP = /^function ([_$a-zA-Z\xA0-\uFFFF][_$a-zA-Z0-9\xA0-\uFFFF]*)?(\([^\)]*\))[\s\S]+$/;

var SyntaxErrorReporter = function () {
  _createClass(SyntaxErrorReporter, [{
    key: '_getTopic',
    value: function _getTopic(descriptor) {
      if (descriptor === undefined) {
        return null;
      }

      if ('value' in descriptor) {
        return descriptor.value;
      }

      if ('get' in descriptor) {
        return descriptor.get;
      }

      if ('set' in descriptor) {
        return descriptor.set;
      }
    }
  }, {
    key: '_extractTopicSignature',
    value: function _extractTopicSignature(topic) {
      switch (typeof topic === 'undefined' ? 'undefined' : _typeof$1(topic)) {
        case 'function':
          return this._extractFunctionSignature(topic);
        default:
          return this.key;
      }
    }
  }, {
    key: '_extractFunctionSignature',
    value: function _extractFunctionSignature(fn) {
      var _this = this;

      return fn.toString().replace(FUNCTION_REGEXP, function (match) {
        var name = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _this.key;
        var params = arguments[2];
        return name + params;
      });
    }
  }, {
    key: 'key',
    get: function get$$1() {
      return this.childDescriptor.key;
    }
  }, {
    key: 'parentNotation',
    get: function get$$1() {
      return this.parentKlass.constructor.name + '#' + this.parentPropertySignature;
    }
  }, {
    key: 'childNotation',
    get: function get$$1() {
      return this.childKlass.constructor.name + '#' + this.childPropertySignature;
    }
  }, {
    key: 'parentTopic',
    get: function get$$1() {
      return this._getTopic(this.parentDescriptor);
    }
  }, {
    key: 'childTopic',
    get: function get$$1() {
      return this._getTopic(this.childDescriptor);
    }
  }, {
    key: 'parentPropertySignature',
    get: function get$$1() {
      return this._extractTopicSignature(this.parentTopic);
    }
  }, {
    key: 'childPropertySignature',
    get: function get$$1() {
      return this._extractTopicSignature(this.childTopic);
    }
  }]);

  function SyntaxErrorReporter(parentKlass, childKlass, parentDescriptor, childDescriptor) {
    _classCallCheck(this, SyntaxErrorReporter);

    this.parentKlass = parentKlass;
    this.childKlass = childKlass;
    this.parentDescriptor = parentDescriptor;
    this.childDescriptor = childDescriptor;
  }

  _createClass(SyntaxErrorReporter, [{
    key: 'assert',
    value: function assert(condition) {
      var msg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';

      if (condition !== true) {
        this.error(GENERIC_FUNCTION_ERROR + msg);
      }
    }
  }, {
    key: 'error',
    value: function error(msg) {
      var _this2 = this;

      msg = msg
      // Replace lazily, because they actually might not
      // be available in all cases
      .replace('{parent}', function (m) {
        return _this2.parentNotation;
      }).replace('{child}', function (m) {
        return _this2.childNotation;
      });
      throw new SyntaxError(msg);
    }
  }]);

  return SyntaxErrorReporter;
}();

function _toConsumableArray$1(arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) {
      arr2[i] = arr[i];
    }return arr2;
  } else {
    return Array.from(arr);
  }
}

var defineProperty$3 = Object.defineProperty;
var getPrototypeOf = Object.getPrototypeOf;

var mapStore = void 0;

function getBoundSuper(obj, fn) {
  if (typeof WeakMap === 'undefined') {
    throw new Error('Using @autobind on ' + fn.name + '() requires WeakMap support due to its use of super.' + fn.name + '()\n      See https://github.com/jayphelps/core-decorators.js/issues/20');
  }

  if (!mapStore) {
    mapStore = new WeakMap();
  }

  if (mapStore.has(obj) === false) {
    mapStore.set(obj, new WeakMap());
  }

  var superStore = mapStore.get(obj);

  if (superStore.has(fn) === false) {
    superStore.set(fn, bind(fn, obj));
  }

  return superStore.get(fn);
}

function autobindClass(klass) {
  var descs = getOwnPropertyDescriptors(klass.prototype);
  var keys = getOwnKeys(descs);

  for (var i = 0, l = keys.length; i < l; i++) {
    var key = keys[i];
    var desc = descs[key];

    if (typeof desc.value !== 'function' || key === 'constructor') {
      continue;
    }

    defineProperty$3(klass.prototype, key, autobindMethod(klass.prototype, key, desc));
  }
}

function autobindMethod(target, key, _ref) {
  var fn = _ref.value,
      configurable = _ref.configurable,
      enumerable = _ref.enumerable;

  if (typeof fn !== 'function') {
    throw new SyntaxError('@autobind can only be used on functions, not: ' + fn);
  }

  var constructor = target.constructor;

  return {
    configurable: configurable,
    enumerable: enumerable,

    get: function get() {
      // Class.prototype.key lookup
      // Someone accesses the property directly on the prototype on which it is
      // actually defined on, i.e. Class.prototype.hasOwnProperty(key)
      if (this === target) {
        return fn;
      }

      // Class.prototype.key lookup
      // Someone accesses the property directly on a prototype but it was found
      // up the chain, not defined directly on it
      // i.e. Class.prototype.hasOwnProperty(key) == false && key in Class.prototype
      if (this.constructor !== constructor && getPrototypeOf(this).constructor === constructor) {
        return fn;
      }

      // Autobound method calling super.sameMethod() which is also autobound and so on.
      if (this.constructor !== constructor && key in this.constructor.prototype) {
        return getBoundSuper(this, fn);
      }

      var boundFn = bind(fn, this);

      defineProperty$3(this, key, {
        configurable: true,
        writable: true,
        // NOT enumerable when it's a bound method
        enumerable: false,
        value: boundFn
      });

      return boundFn;
    },

    set: createDefaultSetter(key)
  };
}

function handle(args) {
  if (args.length === 1) {
    return autobindClass.apply(undefined, _toConsumableArray$1(args));
  } else {
    return autobindMethod.apply(undefined, _toConsumableArray$1(args));
  }
}

function autobind() {
  for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  if (args.length === 0) {
    return function () {
      return handle(arguments);
    };
  } else {
    return handle(args);
  }
}

function _toConsumableArray$2(arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) {
      arr2[i] = arr[i];
    }return arr2;
  } else {
    return Array.from(arr);
  }
}

function _toArray(arr) {
  return Array.isArray(arr) ? arr : Array.from(arr);
}

var defineProperty$4 = Object.defineProperty;

function handleDescriptor$11(target, key, descriptor, _ref) {
  var _ref2 = _toArray(_ref),
      decorator = _ref2[0],
      args = _ref2.slice(1);

  var configurable = descriptor.configurable,
      enumerable = descriptor.enumerable,
      writable = descriptor.writable;

  var originalGet = descriptor.get;
  var originalSet = descriptor.set;
  var originalValue = descriptor.value;
  var isGetter = !!originalGet;

  return {
    configurable: configurable,
    enumerable: enumerable,
    get: function get() {
      var fn = isGetter ? originalGet.call(this) : originalValue;
      var value = decorator.call.apply(decorator, [this, fn].concat(_toConsumableArray$2(args)));

      if (isGetter) {
        return value;
      } else {
        var desc = {
          configurable: configurable,
          enumerable: enumerable
        };

        desc.value = value;
        desc.writable = writable;

        defineProperty$4(this, key, desc);

        return value;
      }
    },

    set: isGetter ? originalSet : createDefaultSetter()
  };
}

function decorate$1() {
  for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  return decorate(handleDescriptor$11, args);
}

var labels = {};

// Exported for mocking in tests
var defaultConsole = {
  time: console.time ? console.time.bind(console) : function (label) {
    labels[label] = new Date();
  },
  timeEnd: console.timeEnd ? console.timeEnd.bind(console) : function (label) {
    var timeNow = new Date();
    var timeTaken = timeNow - labels[label];
    delete labels[label];
    console.log(label + ': ' + timeTaken + 'ms');
  }
};

// Exported for mocking in tests
var defaultConsole$1 = {
  profile: console.profile ? bind(console.profile, console) : function () {},
  profileEnd: console.profileEnd ? bind(console.profileEnd, console) : function () {},
  warn: warn
};

/**
 * core-decorators.js
 * (c) 2017 Jay Phelps and contributors
 * MIT Licensed
 * https://github.com/jayphelps/core-decorators.js
 * @license
 */

function _classCallCheck$3(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

// utils
/**
 * @private
 *
 * @class ReactCacheKey
 *
 * @classdesc
 * cache key used specifically for react components
 */

var ReactCacheKey = function () {
  function ReactCacheKey(key) {
    _classCallCheck$3(this, ReactCacheKey);

    this.key = null;

    this.key = {
      context: this._getKeyPart(key[1]),
      props: this._getKeyPart(key[0])
    };

    return this;
  }

  /**
   * @function _getKeyPart
   * @memberof ReactCacheKey
   * @instance
   *
   * @description
   * get the object of metadata for the key part
   *
   * @param {Object} keyPart the key part to get the metadata of
   * @returns {Object} the metadata for the key part
   */
  ReactCacheKey.prototype._getKeyPart = function _getKeyPart(keyPart) {
    var keys = keyPart ? Object.keys(keyPart) : [];

    return {
      keys: keys,
      size: keys.length,
      value: keyPart
    };
  };

  /**
   * @function _isPropShallowEqual
   * @memberof ReactCacheKey
   * @instance
   *
   * @description
   * check if the prop value passed is equal to the key's value
   *
   * @param {Object} object the new key to test against the instance
   * @param {Object} existing the key object stored in the instance
   * @param {Array<string>} existing.keys the keys of the existing object
   * @param {number} existing.size the length of the keys array
   * @param {Object} value the value of the key part
   * @returns {boolean} is the prop value shallow equal to the object
   */

  ReactCacheKey.prototype._isPropShallowEqual = function _isPropShallowEqual(object, existing) {
    if (getKeyCount(object) !== existing.size) {
      return false;
    }

    var index = 0,
        key = void 0;

    while (index < existing.size) {
      key = existing.keys[index];

      if (object[key] !== existing.value[key]) {
        return false;
      }

      index++;
    }

    return true;
  };

  /**
   * @function _isPropCustomEqual
   * @memberof ReactCacheKey
   * @instance
   *
   * @description
   * check if the prop value passed is equal to the key's value
   *
   * @param {Object} object the new key to test against the instance
   * @param {Object} existingObject the key stored in the instance
   * @param {function} isEqual custom equality comparator
   * @returns {boolean} are the objects equal based on the isEqual method passed
   */

  ReactCacheKey.prototype._isPropCustomEqual = function _isPropCustomEqual(object, existingObject, isEqual) {
    return isEqual(object, existingObject);
  };

  /**
   * @function matches
   * @memberof ReactCacheKey
   * @instance
   *
   * @description
   * does the passed key match the key in the instance
   *
   * @param {Array<*>} key the key to test
   * @returns {boolean} does the key passed match that in the instance
   */

  ReactCacheKey.prototype.matches = function matches(key) {
    return this._isPropShallowEqual(key[0], this.key.props) && this._isPropShallowEqual(key[1], this.key.context);
  };

  /**
   * @function matchesCustom
   * @memberof ReactCacheKey
   * @instance
   *
   * @description
   * does the passed key match the key in the instance
   *
   * @param {Array<*>} key the key to test
   * @param {function} isEqual method to check equality of keys
   * @returns {boolean} does the key passed match that in the instance
   */

  ReactCacheKey.prototype.matchesCustom = function matchesCustom(key, isEqual) {
    return this._isPropCustomEqual(key[0], this.key.props.value, isEqual) && this._isPropCustomEqual(key[1], this.key.context.value, isEqual);
  };

  return ReactCacheKey;
}();

function _classCallCheck$4(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

/**
 * @private
 *
 * @class SerializedCacheKey
 *
 * @classdesc
 * cache key used when the parameters should be serialized
 */
var SerializedCacheKey = function () {
  function SerializedCacheKey(key) {
    _classCallCheck$4(this, SerializedCacheKey);

    this.key = null;

    this.key = key;

    return this;
  }

  /**
   * @function matches
   * @memberof SerializedCacheKey
   * @instance
   *
   * @description
   * does the passed key match the key in the instance
   *W
   * @param {Array<*>} key the key to test
   * @returns {boolean} does the key passed match that in the instance
   */
  SerializedCacheKey.prototype.matches = function matches(key) {
    return key === this.key;
  };

  /**
   * @function matchesCustom
   * @memberof SerializedCacheKey
   * @instance
   *
   * @description
   * does the passed key match the key in the instance based on the custom equality function passed
   *
   * @param {Array<*>} key the key to test
   * @param {function} isEqual method to compare equality of the keys
   * @returns {boolean} does the key passed match that in the instance
   */

  SerializedCacheKey.prototype.matchesCustom = function matchesCustom(key, isEqual) {
    return isEqual(key, this.key);
  };

  return SerializedCacheKey;
}();

function _classCallCheck$5(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

/**
 * @private
 *
 * @class SingleParameterCacheKey
 *
 * @classdesc
 * cache key used when there is a single standard parameter
 */
var SingleParameterCacheKey = function () {
  function SingleParameterCacheKey(key) {
    _classCallCheck$5(this, SingleParameterCacheKey);

    this.isMultiParamKey = false;
    this.key = null;

    this.key = key[0];

    return this;
  }

  /**
   * @function matches
   * @memberof SingleParameterCacheKey
   * @instance
   *
   * @description
   * does the passed key match the key in the instance
   *
   * @param {Array<*>} key the key to test
   * @param {boolean} isMultiParamKey is the key a multi-parameter key
   * @returns {boolean} does the key passed match that in the instance
   */
  SingleParameterCacheKey.prototype.matches = function matches(key, isMultiParamKey) {
    return !isMultiParamKey && key[0] === this.key;
  };

  /**
   * @function matchesCustom
   * @memberof SingleParameterCacheKey
   * @instance
   *
   * @description
   * does the passed key match the key in the instance based on the custom equality function passed
   *
   * @param {Array<*>} key the key to test
   * @param {boolean} isMultiParamKey is the key a multi-parameter key
   * @param {function} isEqual method to compare equality of the keys
   * @returns {boolean} does the key passed match that in the instance
   */

  SingleParameterCacheKey.prototype.matchesCustom = function matchesCustom(key, isMultiParamKey, isEqual) {
    return !isMultiParamKey && isEqual(key[0], this.key);
  };

  return SingleParameterCacheKey;
}();

function _classCallCheck$6(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

/**
 * @private
 *
 * @class MultipleParameterCacheKey
 *
 * @classdesc
 * cache key used when there are multiple standard parameters
 */
var MultipleParameterCacheKey = function () {
  function MultipleParameterCacheKey(key) {
    _classCallCheck$6(this, MultipleParameterCacheKey);

    this.isMultiParamKey = true;
    this.key = null;
    this.size = 0;

    this.key = key;
    this.size = key.length;

    return this;
  }

  /**
   * @function matches
   * @memberof MultipleParameterCacheKey
   * @instance
   *
   * @description
   * does the passed key match the key in the instance
   *
   * @param {Array<*>} key the key to test
   * @param {boolean} isMultiParamKey is the key a multi-parameter key
   * @returns {boolean} does the key passed match that in the instance
   */
  MultipleParameterCacheKey.prototype.matches = function matches(key, isMultiParamKey) {
    if (!isMultiParamKey || key.length !== this.size) {
      return false;
    }

    var index = 0;

    while (index < this.size) {
      if (key[index] !== this.key[index]) {
        return false;
      }

      index++;
    }

    return true;
  };

  /**
   * @function matchesCustom
   * @memberof SingleParameterCacheKey
   * @instance
   *
   * @description
   * does the passed key match the key in the instance based on the custom equality function passed
   *
   * @param {Array<*>} key the key to test
   * @param {boolean} isMultiParamKey is the key a multi-parameter key
   * @param {function} isEqual method to compare equality of the keys
   * @returns {boolean} does the key passed match that in the instance
   */

  MultipleParameterCacheKey.prototype.matchesCustom = function matchesCustom(key, isMultiParamKey, isEqual) {
    return isMultiParamKey && isEqual(key, this.key);
  };

  return MultipleParameterCacheKey;
}();

var _typeof$6 = typeof Symbol === "function" && _typeof(Symbol.iterator) === "symbol" ? function (obj) {
  return typeof obj === "undefined" ? "undefined" : _typeof(obj);
} : function (obj) {
  return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj === "undefined" ? "undefined" : _typeof(obj);
};

var FINITE_POSITIVE_INTEGER = /^[1-9]\d*$/;

/**
 * @private
 *
 * @constant {RegExp} FUNCTION_NAME_REGEXP
 */
var FUNCTION_NAME_REGEXP = /^\s*function\s+([^\(\s]*)\s*/;

/**
 * @private
 *
 * @constant {string} FUNCTION_TYPEOF
 * @default
 */
var FUNCTION_TYPEOF = 'function';

/**
 * @private
 *
 * @constant {Array<Object>} GOTCHA_OBJECT_CLASSES
 */
var GOTCHA_OBJECT_CLASSES = [Boolean, Date, Number, RegExp, String];

/**
 * @private
 *
 * @constant {number} INFINITY
 * @default
 */
var INFINITY = Number.POSITIVE_INFINITY;

/**
 * @private
 *
 * @constant {string} INVALID_FIRST_PARAMETER_ERROR
 * @default
 */
var INVALID_FIRST_PARAMETER_ERROR = 'You must pass either a function or an object of options as the first parameter to moize.';

/**
 * @private
 *
 * @constant {string} INVALID_PROMISE_LIBRARY_ERROR
 * @default
 */
var INVALID_PROMISE_LIBRARY_ERROR = 'The promiseLibrary passed must either be a function or an object with the resolve / reject methods.';

/**
 * @private
 *
 * @constant {function|undefined} NATIVE_PROMISE
 */
var NATIVE_PROMISE = (typeof Promise === 'undefined' ? 'undefined' : _typeof$6(Promise)) === FUNCTION_TYPEOF ? Promise : undefined;

/**
 * @private
 *
 * @constant {Object} DEFAULT_OPTIONS
 */
var DEFAULT_OPTIONS = {
  equals: null,
  isPromise: false,
  isReact: false,
  maxAge: INFINITY,
  maxArgs: INFINITY,
  maxSize: INFINITY,
  promiseLibrary: NATIVE_PROMISE,
  serialize: false,
  serializeFunctions: false,
  serializer: null,
  transformArgs: null
};

/**
 * @private
 *
 * @constant {string} OBJECT_TYPEOF
 * @default
 */
var OBJECT_TYPEOF = 'object';

/**
 * @private
 *
 * @constant {Array<string>} STATIC_PROPERTIES_TO_PASS
 */
var STATIC_PROPERTIES_TO_PASS = ['contextTypes', 'defaultProps', 'propTypes'];

/**
 * @private
 *
 * @constant {{isPromise: true}} PROMISE_OPTIONS
 */
var PROMISE_OPTIONS = {
  isPromise: true
};

/**
 * @private
 *
 * @constant {{maxArgs: number, serialize: boolean, serializeFunctions: boolean}} REACT_OPTIONS
 */
var REACT_OPTIONS = {
  isReact: true
};

/**
 * @private
 *
 * @constant {{serialize: boolean}} SERIALIZE_OPTIONS
 */
var SERIALIZE_OPTIONS = {
  serialize: true
};

// cache
// types


// utils
/**
 * @private
 *
 * @function customReplacer
 *
 * @description
 * custom replacer for the stringify function
 *
 * @param {string} key key in json object
 * @param {*} value value in json object
 * @returns {*} if function then toString of it, else the value itself
 */
var customReplacer = function customReplacer(key, value) {
  return isFunction(value) ? '' + value : value;
};

/**
 * @private
 *
 * @function decycle
 *
 * @description
 * ES2015-ified version of cycle.decyle
 *
 * @param {*} object object to stringify
 * @returns {string} stringified value of object
 */
var decycle = function decycle(object) {
  var cache = new Cache();

  /**
   * @private
   *
   * @function coalesceCircularReferences
   *
   * @description
   * recursive method to replace any circular references with a placeholder
   *
   * @param {*} value value in object to decycle
   * @param {string} path path to reference
   * @returns {*} clean value
   */
  var coalesceCircularReferences = function coalesceCircularReferences(value, path) {
    if (!isValueObjectOrArray(value)) {
      return value;
    }

    if (cache.has(value)) {
      return {
        $ref: cache.get(value)
      };
    }

    cache.add(value, path);

    if (Array.isArray(value)) {
      return value.map(function (item, itemIndex) {
        return coalesceCircularReferences(item, path + '[' + itemIndex + ']');
      });
    }

    return Object.keys(value).reduce(function (object, name) {
      object[name] = coalesceCircularReferences(value[name], path + '[' + JSON.stringify(name) + ']');

      return object;
    }, {});
  };

  return coalesceCircularReferences(object, '$');
};

/**
 * @private
 *
 * @function stringify
 *
 * @description
 * stringify with a custom replacer if circular, else use standard JSON.stringify
 *
 * @param {*} value value to stringify
 * @param {function} [replacer] replacer to used in stringification
 * @returns {string} the stringified version of value
 */
var stringify = function stringify(value, replacer) {
  try {
    return JSON.stringify(value, replacer);
  } catch (exception) {
    return JSON.stringify(decycle(value), replacer);
  }
};

/**
 * @private
 *
 * @function getStringifiedArgument
 *
 * @description
 * get the stringified version of the argument passed
 *
 * @param {*} arg argument to stringify
 * @param {function} [replacer] replacer to used in stringification
 * @returns {string}
 */
var getStringifiedArgument = function getStringifiedArgument(arg, replacer) {
  return isComplexObject(arg) || isFunction(arg) ? stringify(arg, replacer) : arg;
};

/**
 * @private
 *
 * @function createArgumentSerializer
 *
 * @description
 * create the internal argument serializer based on the options passed
 *
 * @param {boolean} serializeFunctions should functions be included in the serialization
 * @param {number} maxArgs the cap on the number of arguments used in serialization
 * @returns {function(...Array<*>): string} argument serialization method
 */
var createArgumentSerializer = function createArgumentSerializer(_ref) {
  var maxArgs = _ref.maxArgs,
      serializeFunctions = _ref.serializeFunctions;

  var replacer = serializeFunctions ? customReplacer : null;
  var hasMaxArgs = isFiniteAndPositiveInteger(maxArgs);

  return function (args) {
    var length = hasMaxArgs ? maxArgs : args.length;

    var index = -1,
        key = '|',
        value = void 0;

    while (++index < length) {
      value = getStringifiedArgument(args[index], replacer);

      if (value) {
        key += value + '|';
      }
    }

    return key;
  };
};

/**
 * @private
 *
 * @function getSerializerFunction
 *
 * @description
 * based on the options passed, either use the serializer passed or generate the internal one
 *
 * @param {Options} options the options passed to the moized function
 * @returns {function} the function to use in serializing the arguments
 */
var getSerializerFunction = function getSerializerFunction(options) {
  return isFunction(options.serializer) ? options.serializer : createArgumentSerializer(options);
};

var _extends$10 = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }return target;
};

var _typeof$5 = typeof Symbol === "function" && _typeof(Symbol.iterator) === "symbol" ? function (obj) {
  return typeof obj === "undefined" ? "undefined" : _typeof(obj);
} : function (obj) {
  return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj === "undefined" ? "undefined" : _typeof(obj);
};

// cache
// cache key
// constants
// serialize
// types


/**
 * @private
 *
 * @function isComplexObject
 *
 * @description
 * is the object passed a complex object
 *
 * @param {*} object object to test if it is complex
 * @returns {boolean} is it a complex object
 */
var isComplexObject = function isComplexObject(object) {
  return !!object && (typeof object === 'undefined' ? 'undefined' : _typeof$5(object)) === OBJECT_TYPEOF;
};

/**
 * @private
 *
 * @function isFiniteAndPositiveInteger
 *
 * @description
 * is the number passed an integer that is finite and positive
 *
 * @param {number} number number to test for finiteness and positivity
 * @returns {boolean} is the number finite and positive
 */
var isFiniteAndPositiveInteger = function isFiniteAndPositiveInteger(number) {
  return FINITE_POSITIVE_INTEGER.test('' + number);
};

/**
 * @private
 *
 * @function isFunction
 *
 * @description
 * is the object passed a function or not
 *
 * @param {*} object object to test
 * @returns {boolean} is it a function
 */
var isFunction = function isFunction(object) {
  return (typeof object === 'undefined' ? 'undefined' : _typeof$5(object)) === FUNCTION_TYPEOF;
};

/**
 * @private
 *
 * @function isMoized
 *
 * @description
 * is the function passed a moized function or not
 *
 * @param {*} fn the function to get if moize
 * @returns {boolean} is the function moized or not
 */
var isMoized = function isMoized(fn) {
  return isFunction(fn) && !!fn.isMoized;
};

/**
 * @private
 *
 * @function isPlainObject
 *
 * @description
 * is the object passed a plain object or not
 *
 * @param {*} object object to test
 * @returns {boolean} is it a plain object
 */
var isPlainObject = function isPlainObject(object) {
  return isComplexObject(object) && object.constructor === Object;
};

/**
 * @private
 *
 * @function isValueObjectOrArray
 *
 * @description
 * check if the object is actually an object or array
 *
 * @param {*} object object to test
 * @returns {boolean} is the object an object or array
 */
var isValueObjectOrArray = function isValueObjectOrArray(object) {
  if (!isComplexObject(object)) {
    return false;
  }

  var index = 0;

  while (index < GOTCHA_OBJECT_CLASSES.length) {
    if (object instanceof GOTCHA_OBJECT_CLASSES[index]) {
      return false;
    }

    index++;
  }

  return true;
};

/**
 * @private
 *
 * @function take
 *
 * @description
 * take the first N number of items from the array (faster than slice)
 *
 * @param {number} size the number of items to take
 * @returns {function(Array<*>): Array<*>} the shortened array
 */
var take = function take(size) {
  return function (array) {
    if (size >= array.length) {
      return array;
    }

    switch (size) {
      case 1:
        return [array[0]];

      case 2:
        return [array[0], array[1]];

      case 3:
        return [array[0], array[1], array[2]];

      case 4:
        return [array[0], array[1], array[2], array[3]];

      case 5:
        return [array[0], array[1], array[2], array[3], array[4]];
    }

    return array.slice(0, size);
  };
};

/**
 * @private
 *
 * @function addStaticPropertiesToFunction
 *
 * @description
 * add static properties to the memoized function if they exist on the original
 *
 * @param {function} originalFunction the function to be memoized
 * @param {function} memoizedFn the higher-order memoized function
 * @returns {function} memoizedFn with static properties added
 */
var addStaticPropertiesToFunction = function addStaticPropertiesToFunction(originalFunction, memoizedFn) {
  var index = STATIC_PROPERTIES_TO_PASS.length,
      property = void 0;

  while (index--) {
    property = STATIC_PROPERTIES_TO_PASS[index];

    if (originalFunction[property]) {
      memoizedFn[property] = originalFunction[property];
    }
  }

  return memoizedFn;
};

/**
 * @private
 *
 * @function compose
 *
 * @description
 * method to compose functions and return a single function
 *
 * @param {...Array<function>} functions the functions to compose
 * @returns {function(...Array<*>): *} the composed function
 */
var compose = function compose() {
  for (var _len = arguments.length, functions = Array(_len), _key = 0; _key < _len; _key++) {
    functions[_key] = arguments[_key];
  }

  return functions.reduce(function (f, g) {
    return function () {
      return f(g.apply(undefined, arguments));
    };
  });
};

/**
 * @private
 *
 * @function createCurriableOptionMethod
 *
 * @description
 * create a method that will curry moize with the option + value passed
 *
 * @param {function} fn the method to call
 * @param {string} option the name of the option to apply
 * @param {*} value the value to assign to option
 * @returns {function} the moizer with the option pre-applied
 */
var createCurriableOptionMethod = function createCurriableOptionMethod(fn, option) {
  return function (value) {
    var _fn;

    return fn((_fn = {}, _fn[option] = value, _fn));
  };
};

/**
 * @private
 *
 * @function createFindIndex
 *
 * @description
 * create a findIndex method based on the startingIndex passed
 *
 * @param {number} startingIndex the index to start in the find method returned
 * @returns {function(Array<ListItem>, *): number} the findIndex method
 */
var createFindIndex = function createFindIndex(startingIndex) {
  // eslint-disable-line no-use-before-define
  return function (list, key) {
    var index = startingIndex;

    while (index < list.length) {
      if (key === list[index].key) {
        return index;
      }

      index++;
    }

    return -1;
  };
};

/**
 * @private
 *
 * @function createPluckFromInstanceList
 *
 * @description
 * get a property from the list on the cache
 *
 * @param {{list: Array<Object>}} cache cache whose list to map over
 * @param {string} key key to pluck from list
 * @returns {Array<*>} array of values plucked at key
 */
var createPluckFromInstanceList = function createPluckFromInstanceList(cache, key) {
  return function () {
    return cache.list.map(function (item) {
      return item[key];
    });
  };
};

/**
 * @private
 *
 * @function createPromiseRejecter
 *
 * @description
 * create method that will reject the promise and delete the key from cache
 *
 * @param {Cache} cache cache to update
 * @param {*} key key to delete from cache
 * @param {function} promiseLibrary the promise library used
 * @returns {function} the rejecter function for the promise
 */
var createPromiseRejecter = function createPromiseRejecter(cache, key, _ref) {
  var promiseLibrary = _ref.promiseLibrary;

  return function (exception) {
    cache.remove(key);

    return promiseLibrary.reject(exception);
  };
};

/**
 * @private
 *
 * @function createPromiseResolver
 *
 * @description
 * create method that will resolve the promise and update the key in cache
 *
 * @param {Cache} cache cache to update
 * @param {*} key key to update in cache
 * @param {boolean} hasMaxAge should the cache expire after some time
 * @param {number} maxAge the age after which the cache will be expired
 * @param {function} onExpire a callback that is called after removing the key
 * @param {function} promiseLibrary the promise library used
 * @returns {function} the resolver function for the promise
 */
var createPromiseResolver = function createPromiseResolver(cache, key, hasMaxAge, _ref2) {
  var maxAge = _ref2.maxAge,
      onExpire = _ref2.onExpire,
      promiseLibrary = _ref2.promiseLibrary;

  return function (resolvedValue) {
    cache.update(key, promiseLibrary.resolve(resolvedValue));

    if (hasMaxAge) {
      cache.expireAfter(key, maxAge, onExpire);
    }

    return resolvedValue;
  };
};

/**
 * @private
 *
 * @function findIndex
 *
 * @description
 * find the index of the key starting at the first index
 *
 * @param {Array<ListItem>} list the list to find the key in
 * @param {*} key the key to test against
 * @returns {number} the index of the matching key, or -1
 */
var findIndex = createFindIndex(0);

/**
 * @private
 *
 * @function findIndexAfterFirst
 *
 * @description
 * find the index of the key starting at the second index
 *
 * @param {Array<ListItem>} list the list to find the key in
 * @param {*} key the key to test against
 * @returns {number} the index of the matching key, or -1
 */
var findIndexAfterFirst = createFindIndex(1);

/**
 * @private
 *
 * @function getDefaultedOptions
 *
 * @description
 * get the options coalesced to their defaults
 *
 * @param {Object} options the options passed to the moize method
 * @returns {Options} the coalesced options object
 */
var getDefaultedOptions = function getDefaultedOptions(options) {
  var coalescedOptions = _extends$10({}, DEFAULT_OPTIONS, options);

  if (coalescedOptions.serialize) {
    coalescedOptions.serializer = getSerializerFunction(coalescedOptions);
  }

  return coalescedOptions;
};

/**
 * @private
 *
 * @function getFunctionNameViaRegexp
 *
 * @description
 * use regexp match on stringified function to get the function name
 *
 * @param {function} fn function to get the name of
 * @returns {string} function name
 */
var getFunctionNameViaRegexp = function getFunctionNameViaRegexp(fn) {
  var match = fn.toString().match(FUNCTION_NAME_REGEXP);

  return match ? match[1] : '';
};

/**
 * @private
 *
 * @function getFunctionName
 *
 * @description
 * get the function name, either from modern property or regexp match,
 * falling back to generic string
 *
 * @param {function} fn function to get the name of
 * @returns {string} function name
 */
var getFunctionName = function getFunctionName(fn) {
  return fn.displayName || fn.name || getFunctionNameViaRegexp(fn) || FUNCTION_TYPEOF;
};

/**
 * @private
 *
 * @function getKeyCount
 *
 * @description
 * get the count of keys in the object (faster than Object.keys().length)
 *
 * @param {Object} object the object to get the key count of
 * @returns {number} the count of keys
 */
var getKeyCount = function getKeyCount(object) {
  var counter = 0;

  for (var ignored in object) {
    counter++;
  }

  return counter;
};

/**
 * @private
 *
 * @function getReactCacheKey
 *
 * @description
 * get the cache key specific to react
 *
 * @param {Cache} cache the cache to find a potential matching key in
 * @param {*} key the key to try to find a match of, or turn into a new ReactCacheKey
 * @returns {ReactCacheKey} the matching cache key, or a new one
 */
var getReactCacheKey = function getReactCacheKey(cache, key) {
  // $FlowIgnore if cache has size, the key exists
  if (cache.size && cache.lastItem.key.matches(key)) {
    // $FlowIgnore if the key matches, the key exists
    return cache.lastItem.key;
  }

  var index = 1;

  while (index < cache.size) {
    // $FlowIgnore if cache has size, the key exists
    if (cache.list[index].key.matches(key)) {
      // $FlowIgnore if the key matches, the key exists
      return cache.list[index].key;
    }

    index++;
  }

  return new ReactCacheKey(key);
};

/**
 * @private
 *
 * @function getReactCacheKey
 *
 * @description
 * get the cache key specific to react
 *
 * @param {Cache} cache the cache to find a potential matching key in
 * @param {*} key the key to try to find a match of, or turn into a new ReactCacheKey
 * @param {Options} options the options passed to the moized method
 * @returns {ReactCacheKey} the matching cache key, or a new one
 */
var getReactCacheKeyCustomEquals = function getReactCacheKeyCustomEquals(cache, key, options) {
  // $FlowIgnore if cache has size, the key exists
  if (cache.size && cache.lastItem.key.matchesCustom(key, options.equals)) {
    // $FlowIgnore if the key matches, the key exists
    return cache.lastItem.key;
  }

  var index = 1;

  while (index < cache.size) {
    // $FlowIgnore if cache has size, the key exists
    if (cache.list[index].key.matchesCustom(key, options.equals)) {
      // $FlowIgnore if the key matches, the key exists
      return cache.list[index].key;
    }

    index++;
  }

  return new ReactCacheKey(key);
};

/**
 * @private
 *
 * @function getSerializedCacheKey
 *
 * @description
 * get the cache key specific to serialized methods
 *
 * @param {Cache} cache the cache to find a potential matching key in
 * @param {*} key the key to try to find a match of, or turn into a new SerializedCacheKey
 * @param {Options} options the options passed to the moized method
 * @returns {SerializedCacheKey} the matching cache key, or a new one
 */
var getSerializedCacheKey = function getSerializedCacheKey(cache, key) {
  // $FlowIgnore if cache has size, the key exists
  if (cache.size && cache.lastItem.key.matches(key)) {
    // $FlowIgnore if the key matches, the key exists
    return cache.lastItem.key;
  }

  var index = 1;

  while (index < cache.size) {
    // $FlowIgnore if cache has size, the key exists
    if (cache.list[index].key.matches(key)) {
      // $FlowIgnore if the key matches, the key exists
      return cache.list[index].key;
    }

    index++;
  }

  return new SerializedCacheKey(key);
};

/**
 * @private
 *
 * @function getSerializedCacheKeyCustomEquals
 *
 * @description
 * get the cache key specific to serialized methods
 *
 * @param {Cache} cache the cache to find a potential matching key in
 * @param {*} key the key to try to find a match of, or turn into a new SerializedCacheKey
 * @param {Options} options the options passed to the moized method
 * @returns {SerializedCacheKey} the matching cache key, or a new one
 */
var getSerializedCacheKeyCustomEquals = function getSerializedCacheKeyCustomEquals(cache, key, options) {
  if (cache.size &&
  // $FlowIgnore if cache has size, the key exists
  cache.lastItem.key.matchesCustom(key, options.equals)) {
    // $FlowIgnore if the key matches, the key exists
    return cache.lastItem.key;
  }

  var index = 1;

  while (index < cache.size) {
    // $FlowIgnore if cache has size, the key exists
    if (cache.list[index].key.matchesCustom(key, options.equals)) {
      // $FlowIgnore if the key matches, the key exists
      return cache.list[index].key;
    }

    index++;
  }

  return new SerializedCacheKey(key);
};

/**
 * @private
 *
 * @function getStandardCacheKey
 *
 * @description
 * get the cache key for standard parameters, either single or multiple
 *
 * @param {Cache} cache the cache to find a potential matching key in
 * @param {*} key the key to try to find a match of, or turn into a new Multiple / SingleParameterCacheKey
 * @returns {StandardCacheKey} the matching cache key, or a new one
 */
var getStandardCacheKey = function getStandardCacheKey(cache, key) {
  var isMultiParamKey = key.length > 1;

  // $FlowIgnore if cache has size, the key exists
  if (cache.size && cache.lastItem.key.matches(key, isMultiParamKey)) {
    // $FlowIgnore if the key matches, the key exists
    return cache.lastItem.key;
  }

  var index = 1;

  while (index < cache.size) {
    // $FlowIgnore if cache has size, the key exists
    if (cache.list[index].key.matches(key, isMultiParamKey)) {
      // $FlowIgnore if the key matches, the key exists
      return cache.list[index].key;
    }

    index++;
  }

  return isMultiParamKey ? new MultipleParameterCacheKey(key) : new SingleParameterCacheKey(key);
};

/**
 * @private
 *
 * @function getStandardCacheKeyCustomEquals
 *
 * @description
 * get the cache key for standard parameters, either single or multiple
 *
 * @param {Cache} cache the cache to find a potential matching key in
 * @param {*} key the key to try to find a match of, or turn into a new Multiple / SingleParameterCacheKey
 * @param {Options} options the options passed to the moized method
 * @returns {StandardCacheKey} the matching cache key, or a new one
 */
var getStandardCacheKeyCustomEquals = function getStandardCacheKeyCustomEquals(cache, key, options) {
  var isMultiParamKey = key.length > 1;

  if (cache.size &&
  // $FlowIgnore if cache has size, the key exists
  cache.lastItem.key.matchesCustom(key, isMultiParamKey, options.equals)) {
    // $FlowIgnore if the key matches, the key exists
    return cache.lastItem.key;
  }

  var index = 1;

  while (index < cache.size) {
    if (
    // $FlowIgnore if cache has size, the key exists
    cache.list[index].key.matchesCustom(key, isMultiParamKey, options.equals)) {
      // $FlowIgnore if the key matches, the key exists
      return cache.list[index].key;
    }

    index++;
  }

  return isMultiParamKey ? new MultipleParameterCacheKey(key) : new SingleParameterCacheKey(key);
};

/**
 * @private
 *
 * @function getGetCacheKeyMethod
 *
 * @description
 * based on the options, get the getCacheKey method
 *
 * @param {Options} options the options passed to the moized method
 * @returns {function(Cache, Array<*>): CacheKey} the cache key
 */
var getGetCacheKeyMethod = function getGetCacheKeyMethod(options) {
  if (options.isReact) {
    return options.equals ? getReactCacheKeyCustomEquals : getReactCacheKey;
  }

  if (options.serialize) {
    return options.equals ? getSerializedCacheKeyCustomEquals : getSerializedCacheKey;
  }

  return options.equals ? getStandardCacheKeyCustomEquals : getStandardCacheKey;
};

/**
 * @private
 *
 * @function createGetCacheKey
 *
 * @description
 * create the method that will get the cache key based on the options passed to the moized method
 *
 * @param {Cache} cache the cache to get the key from
 * @param {Options} options the options passed to the moized method
 * @returns {function(*): CacheKey} the method that will get the cache key
 */
var createGetCacheKey = function createGetCacheKey(cache, options) {
  var hasMaxArgs = isFiniteAndPositiveInteger(options.maxArgs);
  var getCacheKeyMethod = getGetCacheKeyMethod(options);

  var transform = options.transformArgs;

  if (hasMaxArgs) {
    transform = transform ? compose(transform, take(options.maxArgs)) : take(options.maxArgs);
  }

  if (options.serialize) {
    transform = transform ? compose(options.serializer, transform) : options.serializer;
  }

  if (options.equals) {
    if (transform) {
      return function (key) {
        // $FlowIgnore transform is a function
        return getCacheKeyMethod(cache, transform(key), options);
      };
    }

    return function (key) {
      return getCacheKeyMethod(cache, key, options);
    };
  }

  if (transform) {
    return function (key) {
      // $FlowIgnore transform is a function
      return getCacheKeyMethod(cache, transform(key));
    };
  }

  return function (key) {
    return getCacheKeyMethod(cache, key);
  };
};

/**
 * @private
 *
 * @function createSetNewCachedValue
 *
 * @description
 * assign the new value to the key in the functions cache and return the value
 *
 * @param {Cache} cache the cache to assign the value to at key
 * @param {Options} options the options passed to the moize method
 * @returns {function(function, *, *): *} value just stored in cache
 */
var createSetNewCachedValue = function createSetNewCachedValue(cache, options) {
  var hasMaxAge = isFiniteAndPositiveInteger(options.maxAge);
  var hasMaxSize = isFiniteAndPositiveInteger(options.maxSize);

  var maxAge = options.maxAge,
      maxSize = options.maxSize;

  if (options.isPromise) {
    if (!isFunction(options.promiseLibrary) && !isPlainObject(options.promiseLibrary)) {
      throw new TypeError(INVALID_PROMISE_LIBRARY_ERROR);
    }

    return function (key, value) {
      var promiseResolver = createPromiseResolver(cache, key, hasMaxAge, options);
      var promiseRejecter = createPromiseRejecter(cache, key, options);
      var handler = value.then(promiseResolver, promiseRejecter);

      cache.add(key, handler);

      if (hasMaxSize && cache.size > maxSize) {
        cache.remove(cache.list[cache.list.length - 1].key);
      }

      return handler;
    };
  }

  return function (key, value) {
    cache.add(key, value);

    if (hasMaxAge) {
      cache.expireAfter(key, maxAge, options.onExpire);
    }

    if (hasMaxSize && cache.size > maxSize) {
      cache.remove(cache.list[cache.list.length - 1].key);
    }

    return value;
  };
};

/**
 * @private
 *
 * @function splice
 *
 * @description
 * faster version of splicing a single item from the array
 *
 * @param {Array<*>} array array to splice from
 * @param {number} startingIndex index to splice at
 * @returns {Array<*>} array minus the item removed
 */
var splice = function splice(array, startingIndex) {
  if (!array.length) {
    return array;
  }

  var index = startingIndex - 1;

  while (++index < array.length) {
    array[index] = array[index + 1];
  }

  array.length -= 1;

  return array;
};

/**
 * @private
 *
 * @function unshift
 *
 * @description
 * faster version of unshifting a single item into an array
 *
 * @param {Array<*>} array array to unshift into
 * @param {*} item item to unshift into array
 * @returns {*} the item just added to the array
 */
var unshift = function unshift(array, item) {
  var index = array.length;

  while (index--) {
    array[index + 1] = array[index];
  }

  return array[0] = item;
};

/**
 * @private
 *
 * @function createAddPropertiesToFunction
 *
 * @description
 * add the static properties to the moized function
 *
 * @param {Cache} cache the cache for the moized function
 * @param {function} originalFunction the function to be moized
 * @param {Options} options the options passed to the moize method
 * @returns {function(function): function} the method which will add the static properties
 */
var createAddPropertiesToFunction = function createAddPropertiesToFunction(cache, originalFunction, options) {
  var getCacheKey = createGetCacheKey(cache, options);

  return function (moizedFunction) {
    moizedFunction.cache = cache;
    moizedFunction.displayName = 'moize(' + getFunctionName(originalFunction) + ')';
    moizedFunction.isMoized = true;
    moizedFunction.options = options;
    moizedFunction.originalFunction = originalFunction;

    /**
     * @private
     *
     * @function add
     *
     * @description
     * manually add an item to cache if the key does not already exist
     *
     * @param {Array<any>} key key to use in cache
     * @param {*} value value to assign to key
     */
    moizedFunction.add = function (key, value) {
      var internalKey = getCacheKey(key);

      if (!cache.has(internalKey)) {
        cache.add(internalKey, value);
      }
    };

    /**
     * @private
     *
     * @function clear
     *
     * @description
     * clear the current cache for this method
     */
    moizedFunction.clear = function () {
      cache.clear();
    };

    /**
     * @private
     *
     * @function has
     *
     * @description
     * does the function have cache for the specific args passed
     *
     * @param {Array<*>} key combination of args to remove from cache
     * @returns {boolean} does the cache for the give args exist
     */
    moizedFunction.has = function (key) {
      return cache.has(getCacheKey(key));
    };

    /**
     * @private
     *
     * @function keys
     *
     * @description
     * get the list of keys currently in cache
     *
     * @returns {Array<*>}
     */
    moizedFunction.keys = createPluckFromInstanceList(cache, 'key');

    /**
     * @private
     *
     * @function remove
     *
     * @description
     * remove the item from cache for the key passed for this method
     *
     * @param {Array<*>} key combination of args to remove from cache
     */
    moizedFunction.remove = function (key) {
      cache.remove(getCacheKey(key));
    };

    /**
     * @private
     *
     * @function values
     *
     * @description
     * get the list of values currently in cache
     *
     * @returns {Array<*>}
     */
    moizedFunction.values = createPluckFromInstanceList(cache, 'value');

    return addStaticPropertiesToFunction(originalFunction, moizedFunction);
  };
};

function _classCallCheck$2(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

// utils
/**
 * @private
 *
 * @class Cache
 *
 * @classdesc
 * class that is similar to the Map infrastructure, but faster and
 * more targeted to moize use cases
 */

// types

var Cache = function () {
  function Cache() {
    _classCallCheck$2(this, Cache);

    this.lastItem = {};
    this.list = [];
    this.size = 0;
  }

  /**
   * @function add
   * @memberof Cache
   * @instance
   *
   * @description
   * add a new item to cache
   *
   * @param {*} key the key to assign
   * @param {*} value the value to assign at key
   */
  Cache.prototype.add = function add(key, value) {
    this.lastItem = unshift(this.list, {
      key: key,
      value: value
    });

    this.size++;
  };

  /**
   * @function clear
   * @memberof Cache
   * @instance
   *
   * @description
   * clear the cache of all items
   */

  Cache.prototype.clear = function clear() {
    this.lastItem = {};
    this.list.length = this.size = 0;
  };

  /**
   * @function expireAfter
   * @memberof Cache
   * @instance
   *
   * @description
   * remove from cache after maxAge time has passed
   *
   * @param {*} key the key to remove
   * @param {number} maxAge the time in milliseconds to wait before removing the key
   * @param {Function} onExpire a callback that is called after removing the key
   */

  Cache.prototype.expireAfter = function expireAfter(key, maxAge, onExpire) {
    var _this = this;

    setTimeout(function () {
      _this.remove(key);

      if (isFunction(onExpire)) {
        // $FlowIgnore onExpire is a function
        onExpire(key.key);
      }
    }, maxAge);
  };

  /**
   * @function get
   * @memberof Cache
   * @instance
   *
   * @description
   * get the value of an item from cache if it exists
   *
   * @param {*} key the key to get the value of
   * @returns {*} the value at key
   */

  Cache.prototype.get = function get(key) {
    if (!this.size) {
      return;
    }

    if (key === this.lastItem.key) {
      return this.lastItem.value;
    }

    var index = findIndexAfterFirst(this.list, key);

    if (~index) {
      this.lastItem = this.list[index];

      return unshift(splice(this.list, index), this.lastItem).value;
    }
  };

  /**
   * @private
   *
   * @function has
   *
   * @description
   * does the key exist in the cache
   *
   * @param {*} key the key to find in cache
   * @returns {boolean} does the key exist in cache
   */

  Cache.prototype.has = function has(key) {
    return this.size !== 0 && (key === this.lastItem.key || !!~findIndexAfterFirst(this.list, key));
  };

  /**=
   * @function remove
   * @memberof Cache
   * @instance
   *
   * @description
   * remove the item at key from cach
   *
   * @param {*} key the key to remove from cache
   * @returns {void}
   */

  Cache.prototype.remove = function remove(key) {
    var index = findIndex(this.list, key);

    if (~index) {
      splice(this.list, index);

      if (this.size === 1) {
        return this.clear();
      }

      this.size--;

      if (!index) {
        this.lastItem = this.list[0];
      }
    }
  };

  /**
   * @function update
   * @memberof Cache
   * @instance
   *
   * @description
   * update an item in-place with a new value
   *
   * @param {*} key key to update value of
   * @param {*} value value to store in the map at key
   */

  Cache.prototype.update = function update(key, value) {
    var index = findIndex(this.list, key);

    if (~index) {
      this.list[index].value = value;

      if (this.lastItem && key === this.lastItem.key) {
        this.lastItem.value = value;
      }
    }
  };

  return Cache;
}();

var _extends$9 = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }return target;
};

// cache
// constants
// types


// utils
/**
 * @module moize
 */

/**
 * @function moize
 *
 * @description
 * store cached values returned from calling method with arguments to avoid reprocessing data from same arguments
 *
 * @example
 * import moize from 'moize';
 *
 * // standard implementation
 * const fn = (foo, bar) => {
 *  return `${foo} ${bar}`;
 * };
 * const memoizedFn = moize(fn);
 *
 * // implementation with options
 * const fn = async (id) => {
 *  return get(`http://foo.com/${id}`);
 * };
 * const memoizedFn = moize(fn, {
 *  isPromise: true,
 *  maxSize: 5
 * });
 *
 * @param {function} functionOrComposableOptions method to memoize
 * @param {Options} [passedOptions={}] options to customize how the caching is handled
 * @param {boolean} [passedOptions.isPromise=false] is the function return expected to be a promise to resolve
 * @param {number} [passedOptions.maxAge=Infinity] the maximum age the value should persist in cache
 * @param {number} [passedOptions.maxArgs=Infinity] the maximum number of arguments to be used in serializing the keys
 * @param {number} [passedOptions.maxSize=Infinity] the maximum size of the cache to retain
 * @param {function} [passedOptions.promiseLibrary=Promise] promise library to use for resolution / rejection
 * @param {function} [passedOptions.serializeFunctions=false] should function parameters be serialized as well
 * @param {function} [passedOptions.serializer] method to serialize arguments with for cache storage
 * @returns {Function} higher-order function which either returns from cache or newly-computed value
 */
var moize = function moize(functionOrComposableOptions) {
  var passedOptions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  if (isPlainObject(functionOrComposableOptions)) {
    return function (fnOrOptions) {
      var otherOptions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      if (isPlainObject(fnOrOptions)) {
        return moize(_extends$9({}, functionOrComposableOptions, fnOrOptions));
      }

      return moize(fnOrOptions, _extends$9({}, functionOrComposableOptions, otherOptions));
    };
  }

  if (!isFunction(functionOrComposableOptions)) {
    throw new TypeError(INVALID_FIRST_PARAMETER_ERROR);
  }

  var isComposed = functionOrComposableOptions.isMoized;
  // $FlowIgnore if the function is already moized, it has an originalFunction property on it
  var fn = isComposed ? functionOrComposableOptions.originalFunction : functionOrComposableOptions;

  var options = getDefaultedOptions(!isComposed ? passedOptions : _extends$9({}, functionOrComposableOptions.options, passedOptions));

  var cache = new Cache();

  var addPropertiesToFunction = createAddPropertiesToFunction(cache, fn, options);
  var getCacheKey = createGetCacheKey(cache, options);
  var setNewCachedValue = createSetNewCachedValue(cache, options);

  var moizedFunction = function moizedFunction() {
    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var key = getCacheKey(args);

    return cache.size && cache.has(key) ? cache.get(key) : setNewCachedValue(key, fn.apply(this, args));
  };

  return addPropertiesToFunction(moizedFunction);
};

moize.compose = compose;
moize.isMoized = isMoized;
moize.maxAge = createCurriableOptionMethod(moize, 'maxAge');
moize.maxArgs = createCurriableOptionMethod(moize, 'maxArgs');
moize.maxSize = createCurriableOptionMethod(moize, 'maxSize');
moize.promise = moize(PROMISE_OPTIONS);
moize.react = moize(REACT_OPTIONS);
moize.reactSimple = compose(moize.react, moize.maxSize(1));
moize.serialize = moize(SERIALIZE_OPTIONS);
moize.simple = moize.maxSize(1);

var Header = function (_React$PureComponent) {
    inherits(Header, _React$PureComponent);

    function Header() {
        classCallCheck(this, Header);
        return possibleConstructorReturn(this, (Header.__proto__ || Object.getPrototypeOf(Header)).apply(this, arguments));
    }

    createClass(Header, [{
        key: "onSort",
        value: function onSort(rootColIndex, subColIndex) {
            var _this2 = this;

            return function () {
                return _this2.props.onSort(rootColIndex, subColIndex);
            };
        }
    }, {
        key: "render",
        value: function render() {
            var _this3 = this;

            return createElement("thead", null, createElement("tr", { className: styleSheetParser.mainHeader }, this.props.onToggleAll && !this.props.hideSelect ? createElement("th", { rowSpan: 2, className: styleSheetParser.selectHeader }, createElement("input", { type: "checkbox", checked: this.props.areAllRowsSelected, onChange: this.props.onToggleAll })) : null, this.props.columns.map(function (col, i) {
                var isCurrentColumnSorted = rootColumnIndex(_this3.props.columns, i) === _this3.props.currentSortedColumn;
                var rootCol = col;
                return createElement("th", { key: col.label || i, rowSpan: rootCol.subColumns && rootCol.subColumns.length ? 1 : 2, colSpan: rootCol.subColumns && rootCol.subColumns.length ? rootCol.subColumns.length : 1, className: (col.featured ? styleSheetParser.featured : "") + " " + (col.className || "") + " " + (_this3.props.headerCellClassName || "") + " " + (rootCol.subColumns && rootCol.subColumns.length ? styleSheetParser.rootHeader : "") }, col.label, !isRootColumn(col) && col.sort ? createElement("span", { className: styleSheetParser.sortIcon + (isCurrentColumnSorted ? " " + styleSheetParser.activeSortIcon : ""), onClick: _this3.onSort(i) }, createElement("span", { className: isCurrentColumnSorted && _this3.props.ascendant ? styleSheetParser.up : styleSheetParser.down })) : null);
            })), createElement("tr", { className: styleSheetParser.subHeader }, this.props.columns.map(function (col, i) {
                if (isRootColumn(col)) {
                    return col.subColumns.map(function (subCol, j) {
                        var isCurrentColumn = subColumnIndex(_this3.props.columns, j, i) === _this3.props.currentSortedColumn;
                        return createElement("th", { key: col.label + "/" + subCol.label }, subCol.label, subCol.sort ? createElement("span", { className: styleSheetParser.sortIcon + (isCurrentColumn ? " " + styleSheetParser.activeSortIcon : ""), onClick: _this3.onSort(i, j) }, createElement("span", { className: isCurrentColumn && _this3.props.ascendant ? styleSheetParser.down : styleSheetParser.up })) : null);
                    }).reduce(function (arr, cols) {
                        return arr.concat(cols);
                    }, []);
                }
                return null;
            }).filter(function (a) {
                return a;
            })));
        }
    }]);
    return Header;
}(PureComponent);
__decorate([decorate$1(moize)], Header.prototype, "onSort", null);
Header = __decorate([autobind], Header);
var Header$1 = Header;

var lazyload$1 = require("react-lazyload");
var lazyloadDecorator = lazyload$1.lazyload;
var DataRowComponent = function (_React$PureComponent) {
    inherits(DataRowComponent, _React$PureComponent);

    function DataRowComponent() {
        classCallCheck(this, DataRowComponent);
        return possibleConstructorReturn(this, (DataRowComponent.__proto__ || Object.getPrototypeOf(DataRowComponent)).apply(this, arguments));
    }

    createClass(DataRowComponent, [{
        key: "generateCell",
        value: function generateCell(cell, i, nSiblings, siblingPos) {
            var node = cell && (cell.node || cell.computedNode && (Array.isArray(cell.value) ? cell.value.map(cell.computedNode) : cell.computedNode(cell.value)) || cell.value);
            var isArray = Array.isArray(node);
            if (!isArray && siblingPos !== 0) {
                return null;
            } else {
                return createElement("td", { key: i + "@" + (siblingPos || 0), "data-col": i, rowSpan: isArray ? undefined : nSiblings, className: styleSheetParser.cellContent + " " + (cell && cell.className || "") }, isArray ? node[siblingPos] : node);
            }
        }
    }, {
        key: "onSelect",
        value: function onSelect(ev) {
            if (this.props.onSelect) {
                this.props.onSelect(this.props.id, ev.target.checked);
            }
        }
    }, {
        key: "validate",
        value: function validate(props) {
            if (process.env.NODE_ENV !== "production") {
                if (new Set(props.data.filter(Array.isArray).map(function (c) {
                    return Array.isArray(c) && c.length || -1;
                })).size > 1) {
                    console.group("CubeDataTable warning");
                    console.warn("Invalid row: array cells have different lengths");
                    console.warn(props);
                    console.groupEnd();
                }
            }
        }
    }, {
        key: "componentWillReceiveProps",
        value: function componentWillReceiveProps(nextProps) {
            if (nextProps !== this.props) {
                this.validate(nextProps);
            }
        }
    }, {
        key: "componentDidMount",
        value: function componentDidMount() {
            this.validate(this.props);
        }
    }, {
        key: "render",
        value: function render() {
            var _this2 = this;

            var siblings = Math.max.apply(Math, toConsumableArray(this.props.data.map(function (cell) {
                return cell && (cell.node ? Array.isArray(cell.node) : Array.isArray(cell.value)) ? (cell.node || cell.value).length : 1;
            })));
            return createElement("tr", { key: this.props.id + "@" + this.props.sibling, "data-even": this.props.index % 2 === 0 ? true : undefined, className: (this.props.className || "") + " " + (this.props.className || "") + " " + (this.props.selected === false ? styleSheetParser.disabled : "") + " " + (this.props.index % 2 === 0 ? styleSheetParser.odd : styleSheetParser.even) }, !this.props.sibling && this.props.onSelect ? createElement("th", { rowSpan: siblings, className: styleSheetParser.selectHeader }, !this.props.hideSelect && this.props.onSelect ? createElement("input", { type: "checkbox", checked: this.props.selected, onChange: this.onSelect }) : null) : null, this.props.data.map(function (cell, j) {
                return _this2.generateCell(cell, j, siblings, _this2.props.sibling || 0);
            }).filter(function (cell) {
                return cell;
            }));
        }
    }]);
    return DataRowComponent;
}(PureComponent);
DataRowComponent = __decorate([autobind], DataRowComponent);
var DataRowComponent$1 = DataRowComponent;
var VirtualizedDataRow = lazyloadDecorator({ height: 35, offset: 200, once: true })(DataRowComponent);

var lazyload = require("react-lazyload");
function isRootColumn(col) {
    return "subColumns" in col && !!col.subColumns;
}
function rootColumnIndex(columns, i) {
    var cols = columns.slice(0, i + 1);
    return cols.reduce(function (count, col) {
        if (isRootColumn(col)) {
            return col.subColumns.length + count;
        } else {
            return count + 1;
        }
    }, 0) - 1;
}
function subColumnIndex(columns, i, rootIndex) {
    var cols = columns.slice(0, rootIndex);
    return cols.reduce(function (count, col) {
        if (isRootColumn(col)) {
            return col.subColumns.length + count;
        } else {
            return count + 1;
        }
    }, 0) + i;
}
var externalStylesheet = void 0;
var isModule = function isModule(s) {
    return Object.keys(s).length > 0;
};
function loadExternalStyleSheet(extSheet) {
    externalStylesheet = extSheet;
    styleSheetParser = loadStyle();
}
function loadStyle() {
    try {
        var stylesheet = require("./index.scss");
        var s = new Proxy({}, {
            get: function get$$1(_, name) {
                return [stylesheet, externalStylesheet].filter(function (s) {
                    return s;
                }).map(function (s) {
                    return isModule(s) ? stylesheet[name] : name;
                }).join(" ");
            }
        });
        return s;
    } catch (_) {
        return {};
    }
}
var styleSheetParser = loadStyle();
function isNullOrUndefined(v) {
    return v === null || typeof v === "undefined";
}
function isCategorizedRow(row) {
    return "category" in row && !!row.category;
}
function areCategorizedRows(rows) {
    return rows.every(function (row) {
        return isCategorizedRow(row);
    });
}
function getCategorizedRows(rows) {
    var categorizedRows = {};
    if (areCategorizedRows(rows)) {
        rows.forEach(function (row) {
            return categorizedRows[row.category] = (categorizedRows[row.category] || []).concat(row);
        });
    } else {
        categorizedRows[""] = rows;
    }
    return categorizedRows;
}
var CubeDataTable = function (_React$PureComponent) {
    inherits(CubeDataTable, _React$PureComponent);

    function CubeDataTable(props, context) {
        classCallCheck(this, CubeDataTable);

        var _this = possibleConstructorReturn(this, (CubeDataTable.__proto__ || Object.getPrototypeOf(CubeDataTable)).call(this, props, context));

        _this.scrollableParent = null;
        var sortableColumns = props.columns.filter(function (col) {
            return !isRootColumn(col);
        });
        _this.state = {
            ascendant: false,
            currentSortedColumn: sortableColumns.findIndex(function (col) {
                return col.featured && !!col.sort || false;
            }),
            currentSorting: (sortableColumns.find(function (col) {
                return col.featured && !!col.sort || false;
            }) || { sort: undefined }).sort
        };
        _this.validateRowsLength(props);
        return _this;
    }

    createClass(CubeDataTable, [{
        key: "onRef",
        value: function onRef(tableDom) {
            this.tableDom = tableDom;
            this.setScrollableParent(this.getScrollableParent(this.tableDom && this.tableDom.parentElement));
        }
    }, {
        key: "getScrollableParent",
        value: function getScrollableParent(parentStack) {
            while (parentStack) {
                if (parentStack.scrollHeight > parentStack.clientHeight && ["scroll", "auto"].indexOf(window.getComputedStyle(parentStack).overflowY) !== -1) {
                    return parentStack;
                }
                parentStack = parentStack.parentElement;
            }
            return null;
        }
    }, {
        key: "setScrollableParent",
        value: function setScrollableParent(scrollable) {
            if (this.scrollableParent !== scrollable) {
                this.removeScrollListeners();
                if (scrollable) scrollable.addEventListener("scroll", this.scrollHandleSticky, { capture: true, passive: true });
            }
            this.scrollableParent = scrollable;
        }
    }, {
        key: "setStickyTablePosition",
        value: function setStickyTablePosition() {
            if (this.scrollableParent && this.stickyTable && this.stickyTable.parentElement) {
                var tableRect = this.tableDom.getBoundingClientRect();
                var tableTop = tableRect.top;
                var tableHeight = tableRect.height;
                var parentTop = this.scrollableParent.getBoundingClientRect().top;
                var stickyHeight = this.stickyTable.getBoundingClientRect().height;
                var pixelsToEnd = tableTop + tableHeight - parentTop;
                this.stickyTable.style.top = parentTop - tableTop + Math.min(0, pixelsToEnd - stickyHeight) + "px";
            }
        }
    }, {
        key: "windowHandleSticky",
        value: function windowHandleSticky() {
            return this.handleSticky(true);
        }
    }, {
        key: "scrollHandleSticky",
        value: function scrollHandleSticky() {
            return this.handleSticky(false);
        }
    }, {
        key: "handleSticky",
        value: function handleSticky(forceRerender) {
            lazyload.forceCheck();
            if (this.tableDom && this.scrollableParent) {
                var tableRect = this.tableDom.getBoundingClientRect();
                var parentRectTop = this.scrollableParent.getBoundingClientRect().top;
                var isSticky = tableRect.top < parentRectTop;
                var pixelsToEnd = tableRect.top + tableRect.height - parentRectTop;
                var stickyRuleRow = this.getCurrentStickyRuleRow();
                if (stickyRuleRow !== this.state.stickyRuleRow) {
                    this.setState({ stickyRuleRow: stickyRuleRow });
                }
                if (isSticky && this.stickyTable) {
                    this.setStickyTablePosition();
                }
                if (this.state.isSticky !== isSticky && pixelsToEnd > 0) {
                    this.setState({ isSticky: isSticky });
                } else if (pixelsToEnd <= 0 && this.state.isSticky !== false) {
                    this.setState({ isSticky: false });
                }
                if (forceRerender) {
                    this.syncStickyTableStyle();
                }
            }
        }
    }, {
        key: "syncStickyTableStyle",
        value: function syncStickyTableStyle() {
            if (this.stickyTable && this.scrollableParent && this.tableDom) {
                var originalHeader = this.tableDom.querySelector("thead");
                var boundingRect = originalHeader.getBoundingClientRect();
                this.stickyTable.parentElement.style.width = boundingRect.width + "px";
                var originalRows = Array.from(originalHeader.querySelectorAll("tr"));
                var stickyRows = Array.from(this.stickyTable.querySelectorAll("tr"));
                for (var rowIndex in originalRows) {
                    var originalRow = originalRows[rowIndex];
                    var stickyRow = stickyRows[rowIndex];
                    var originalCells = Array.from(originalRow.querySelectorAll("td, th"));
                    var stickyCells = Array.from(stickyRow.querySelectorAll("td, th"));
                    for (var cellIndex in originalCells) {
                        var stickyCell = stickyCells[cellIndex];
                        var originalCell = originalCells[cellIndex];
                        stickyCell.style.width = originalCell.getBoundingClientRect().width + "px";
                    }
                }
            }
        }
    }, {
        key: "componentWillReceiveProps",
        value: function componentWillReceiveProps(nextProps) {
            if (this.props.data === nextProps.data && this.props.columns === nextProps.columns) return;
            this.validateRowsLength(nextProps);
        }
    }, {
        key: "validateRowsLength",
        value: function validateRowsLength(props) {
            if (process && process.env && process.env.NODE_ENV === "production") return;
            if (!props.columns || !props.data && !props.featuredRow) return;
            var rows = props.featuredRow ? [].concat(toConsumableArray(props.data || []), [props.featuredRow]) : props.data || [];
            var columns = props.columns.reduce(function (count, col) {
                return count + (isRootColumn(col) ? col.subColumns.length : 1);
            }, 0);
            var invalidRows = rows.filter(function (row) {
                return row.data.length !== columns;
            });
            if (invalidRows.length > 0) {
                console.groupCollapsed("Warning: invalid CubeDataTable props");
                console.warn("Header has " + columns + " columns and not all rows have the same cell count");
                var _iteratorNormalCompletion = true;
                var _didIteratorError = false;
                var _iteratorError = undefined;

                try {
                    var _loop = function _loop() {
                        var row = _step.value;

                        console.warn("Row #" + rows.findIndex(function (r) {
                            return r.id === row.id;
                        }) + " has invalid cell count (" + row.data.length + "): ", row);
                    };

                    for (var _iterator = invalidRows[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                        _loop();
                    }
                } catch (err) {
                    _didIteratorError = true;
                    _iteratorError = err;
                } finally {
                    try {
                        if (!_iteratorNormalCompletion && _iterator.return) {
                            _iterator.return();
                        }
                    } finally {
                        if (_didIteratorError) {
                            throw _iteratorError;
                        }
                    }
                }

                console.groupEnd();
            }
        }
    }, {
        key: "generateRuleRow",
        value: function generateRuleRow(content) {
            var _this2 = this;

            var rows = this.props.data.filter(function (r) {
                return r.category === content;
            });
            var nOfCols = rootColumnIndex(this.props.columns, this.props.columns.length - 1) + 1;
            var noCategory = "Sem categoria";
            return createElement("tr", { key: content || noCategory, className: styleSheetParser.ruleRow, "data-row-type": "rule" }, this.props.onSelect && !this.props.hideSelects ? createElement("th", { className: styleSheetParser.selectHeader }, createElement("input", { type: "checkbox", onChange: function onChange() {
                    return _this2.toggleAllGivenRows(rows);
                }, checked: rows.length && rows.every(function (r) {
                    return !!r.selected;
                }) || false })) : null, createElement("td", { colSpan: nOfCols }, content || noCategory));
        }
    }, {
        key: "renderRow",
        value: function renderRow(row, index, isTotal) {
            var _this3 = this;

            var siblings = Math.max.apply(Math, toConsumableArray(row.data.map(function (cell) {
                return cell && (cell.node ? Array.isArray(cell.node) : Array.isArray(cell.value)) ? (cell.node || cell.value).length : 1;
            })));
            var DataRowComp = this.props.virtualize ? VirtualizedDataRow : DataRowComponent$1;
            return [].concat(toConsumableArray(new Array(siblings))).map(function (_, i) {
                return createElement(DataRowComp, Object.assign({}, row, { sibling: i, index: index, hideSelect: isTotal, key: row.id + "@" + i, onSelect: !_this3.props.hideSelects ? _this3.props.onSelect : undefined, className: (isTotal ? styleSheetParser.featuredRow : "") + " " + row.className }));
            });
        }
    }, {
        key: "generateCategorizedRows",
        value: function generateCategorizedRows(rows) {
            var _this4 = this;

            var elements = [];
            var categorized = getCategorizedRows(rows);
            var categories = Object.entries(categorized).sort(function (_ref, _ref2) {
                var _ref4 = slicedToArray(_ref, 1),
                    a = _ref4[0];

                var _ref3 = slicedToArray(_ref2, 1),
                    b = _ref3[0];

                return a.localeCompare(b);
            });
            var _iteratorNormalCompletion2 = true;
            var _didIteratorError2 = false;
            var _iteratorError2 = undefined;

            try {
                for (var _iterator2 = categories[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                    var _step2$value = slicedToArray(_step2.value, 2),
                        category = _step2$value[0],
                        categoryRows = _step2$value[1];

                    if (category) {
                        elements.push(this.generateRuleRow(category));
                    }
                    if (categoryRows) {
                        elements.push.apply(elements, toConsumableArray(categoryRows.map(function (row, i) {
                            return _this4.renderRow(row, i);
                        }).reduce(function (acc, arr) {
                            return acc.concat(arr);
                        }, [])));
                        if (this.props.totalFunction) {
                            elements.push.apply(elements, toConsumableArray(this.renderRow(this.props.totalFunction(categoryRows, category), 0, true)));
                        }
                    }
                }
            } catch (err) {
                _didIteratorError2 = true;
                _iteratorError2 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion2 && _iterator2.return) {
                        _iterator2.return();
                    }
                } finally {
                    if (_didIteratorError2) {
                        throw _iteratorError2;
                    }
                }
            }

            return elements;
        }
    }, {
        key: "sortData",
        value: function sortData(data) {
            var _this5 = this;

            return data.sort(function (r1, r2) {
                var currentSorting = _this5.state.currentSorting;
                var currentSortedColumn = _this5.state.currentSortedColumn;
                if (!isNullOrUndefined(currentSorting) && !isNullOrUndefined(currentSortedColumn)) {
                    if (!r1.data[currentSortedColumn] && r2.data[currentSortedColumn]) {
                        return -1;
                    } else if (!r2.data[currentSortedColumn] && r1.data[currentSortedColumn]) {
                        return 1;
                    } else if (!r1.data[currentSortedColumn] && !r2.data[currentSortedColumn]) {
                        return 0;
                    }
                    return currentSorting(r1.data[currentSortedColumn].value, r2.data[currentSortedColumn].value);
                } else {
                    return 0;
                }
            });
        }
    }, {
        key: "onSortRootColumn",
        value: function onSortRootColumn(colId) {
            var col = this.props.columns[colId];
            this.setState({
                currentSorting: col.sort,
                currentSortedColumn: rootColumnIndex(this.props.columns, colId),
                ascendant: col.sort === this.state.currentSorting ? !this.state.ascendant : false
            });
        }
    }, {
        key: "onSort",
        value: function onSort(rootColIndex, subColIndex) {
            if (typeof subColIndex !== "undefined") {
                this.onSortSubColumn(rootColIndex, subColIndex);
            } else {
                this.onSortRootColumn(rootColIndex);
            }
        }
    }, {
        key: "onSortSubColumn",
        value: function onSortSubColumn(rootColId, subColId) {
            var subCol = this.props.columns[rootColId].subColumns[subColId];
            this.setState({
                ascendant: subCol.sort === this.state.currentSorting ? !this.state.ascendant : false,
                currentSortedColumn: subColumnIndex(this.props.columns, subColId, rootColId),
                currentSorting: subCol.sort
            });
        }
    }, {
        key: "render",
        value: function render() {
            if (this.props.placeholder && (!this.props.data || this.props.data.length === 0)) {
                return createElement("div", null, this.props.placeholder);
            }
            return this.renderTable();
        }
    }, {
        key: "componentDidMount",
        value: function componentDidMount() {
            window.addEventListener("resize", this.windowHandleSticky);
        }
    }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
            window.removeEventListener("resize", this.windowHandleSticky);
            this.removeScrollListeners();
        }
    }, {
        key: "removeScrollListeners",
        value: function removeScrollListeners() {
            if (this.scrollableParent) {
                this.scrollableParent.removeEventListener("scroll", this.scrollHandleSticky);
            }
        }
    }, {
        key: "componentDidUpdate",
        value: function componentDidUpdate() {
            if (!this.scrollableParent) {
                this.onRef(this.tableDom);
            }
        }
    }, {
        key: "onStickyTableRef",
        value: function onStickyTableRef(stickyHeader) {
            if (this.stickyTable !== stickyHeader) {
                this.stickyTable = stickyHeader;
                this.setStickyTablePosition();
                this.syncStickyTableStyle();
            }
        }
    }, {
        key: "genHeader",
        value: function genHeader(sticky) {
            var header = this.getHeaderElement();
            if (sticky) {
                return createElement("table", { className: styleSheetParser.portal + " " + styleSheetParser.table, ref: sticky && this.onStickyTableRef || undefined }, header, createElement("tbody", null, this.state.stickyRuleRow && this.generateRuleRow(this.state.stickyRuleRow || "")));
            } else {
                return header;
            }
        }
    }, {
        key: "getCurrentStickyRuleRow",
        value: function getCurrentStickyRuleRow() {
            var headerBottom = this.stickyTable && this.stickyTable.getBoundingClientRect().bottom || 0;
            var ruleRows = Array.from(this.tableDom.querySelectorAll("tr[data-row-type=\"rule\"]"));
            var scrolledRuleRows = ruleRows.filter(function (row) {
                return row.getBoundingClientRect().top <= headerBottom;
            });
            var lastScrolledRuleRow = scrolledRuleRows.reduce(function (r1, r2) {
                if (!r1) return r2;
                var t1 = r1.getBoundingClientRect().top;
                var t2 = r2.getBoundingClientRect().top;
                return t1 > t2 ? r1 : r2;
            }, null);
            return lastScrolledRuleRow && lastScrolledRuleRow.textContent || undefined;
        }
    }, {
        key: "areAllRowsSelected",
        value: function areAllRowsSelected() {
            var rows = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.props.data;

            return rows.every(function (row) {
                return !!row.selected;
            });
        }
    }, {
        key: "toggleAllRows",
        value: function toggleAllRows() {
            return this.toggleAllGivenRows();
        }
    }, {
        key: "toggleAllGivenRows",
        value: function toggleAllGivenRows(rs) {
            if (!this.props.onSelect) {
                console.warn("CubeDataTable: invalid call to toggleAllRows");
                return;
            }
            var rows = rs || this.props.data;
            this.props.onSelect(rows.map(function (row) {
                return row.id;
            }), !this.areAllRowsSelected(rs));
        }
    }, {
        key: "getHeaderElement",
        value: function getHeaderElement() {
            return createElement(Header$1, { areAllRowsSelected: this.areAllRowsSelected(), currentSortedColumn: this.state.currentSortedColumn, onToggleAll: this.toggleAllRows, hideSelect: !this.props.onSelect || this.props.hideSelects || false, columns: this.props.columns, ascendant: this.state.ascendant, headerCellClassName: this.props.headerCellClassName, onSort: this.onSort });
        }
    }, {
        key: "renderTable",
        value: function renderTable() {
            var sortedData = this.state.currentSorting ? this.sortData(this.props.data) : this.props.data;
            if (this.state.currentSorting && this.state.ascendant) {
                sortedData = sortedData.reverse();
            }
            return createElement("div", null, createElement("div", { className: styleSheetParser.wrapper }, this.state.isSticky ? this.genHeader(true) : null, createElement("table", { ref: this.onRef, className: styleSheetParser.table + " " + (this.props.className || "") + " " + styleSheetParser.tableResponsive }, this.genHeader(), createElement("tbody", null, this.props.featuredRow ? this.renderRow(this.props.featuredRow, 0, true) : null, this.generateCategorizedRows(sortedData)))));
        }
    }]);
    return CubeDataTable;
}(PureComponent);
CubeDataTable = __decorate([autobind], CubeDataTable);
var CubeDataTable$1 = CubeDataTable;

export { isRootColumn, rootColumnIndex, subColumnIndex, loadExternalStyleSheet, styleSheetParser, isCategorizedRow, areCategorizedRows };export default CubeDataTable$1;
//# sourceMappingURL=index.es6.js.map
